from Crypto.Cipher import AES
from Crypto.Util.Padding import pad, unpad
from pwn import xor
from tqdm import tqdm
import requests, multiprocessing, string


base_url = 'https://aes.cryptohack.org/'

def encrypt(plaintext: bytes):
    route = '/lazy_cbc/encrypt/{}/'.format(plaintext.hex())
    response = requests.get(base_url + route)
    return bytes.fromhex(response.json()['ciphertext'])

def get_flag(key: bytes):
    route = '/lazy_cbc/get_flag/{}/'.format(key.hex())
    response = requests.get(base_url + route)
    return bytes.fromhex(response.json()['plaintext'])

def receive(ciphertext: bytes):
    route = '/lazy_cbc/receive/{}/'.format(ciphertext.hex())
    response = requests.get(base_url + route)
    return response.json()


ekey = encrypt(b'\0' * 16)
plain = receive(b'\0' * 16 + ekey)['error'].split(':')[-1].strip()
key = bytes.fromhex(plain)[16:]
flag = get_flag(key)
print(flag.decode())